﻿@page "/{threadId}"


@using Texnomic.Blazor.JsonViewer
@using System.Text.Json
@using Wrnu.Were.Model
@inject HttpClient Http
@inject IJSRuntime JS

@if(listOfObjects == null){
    <p>Laddar...</p>
}
else
{
    @if (listOfObjects.Count == 0)
    {
        <p>Inget resultat</p>
    }
    else
    {
        <PageTitle>Resultat</PageTitle>

        <HeadContent>
            A lot of bs!
        </HeadContent>
        
        <Tabs RenderMode="TabsRenderMode.LazyLoad" SelectedTab="@listOfObjects.First().Name">
            <Items>
                @foreach (var voteResult in listOfObjects)
                {
                    <Tab Name="@voteResult.Name">@voteResult.Name</Tab>
                }
                <Tab Name="completeVotes">Samtliga röster</Tab>
            </Items>
            <Content>
                @foreach (var summary in listOfObjects)
                {
                    <TabPanel Name="@summary.Name">
                        <VotingResult summaries="@summary.VoteSummary" topic="@summary.Name"/>
                    </TabPanel>
                }
                <TabPanel Name="completeVotes">
                    <TotalVoting listOfResults="@listOfObjects" threadId="@threadId" />
                </TabPanel>
            </Content>
        </Tabs>
    } 
}

@code{
    protected List<VoteResult>? listOfObjects; 
    
    [ParameterAttribute]
    public string? threadId { get; set; }

    string selectedTab = "Röst";

    private Task OnSelectedTabChanged( string name )
    {
        selectedTab = name;

        return Task.CompletedTask;
    }


    protected async override Task OnInitializedAsync()
    {
        listOfObjects = await Http.GetFromJsonAsync<List<VoteResult>>($"Werewolf/GetCustomVotes?threadId={threadId}&simpleSearch=true");

        if (listOfObjects is null)
        {
            listOfObjects = new List<VoteResult>();
            Console.WriteLine($"Inget resultat på tråd: {threadId}");
        }
        
        Console.WriteLine(JsonSerializer.Serialize(listOfObjects));
        Console.WriteLine($"Items: {listOfObjects.Count}");
    }

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        await base.OnAfterRenderAsync(firstRender);
    }




}